﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Infragistics.Win;
using Infragistics.Win.FormattedLinkLabel;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace SampleUltraGrid
{
    public partial class Form1 : Form
    {
        ControlContainerEditor controlContainerEditor;
        CellInfoControl renderingControl;
        public Form1()
        {
            InitializeComponent();
            this.controlContainerEditor = new ControlContainerEditor();
            renderingControl = new CellInfoControl();
            renderingControl.Name = "RenderingControl";
            this.controlContainerEditor.RenderingControl = renderingControl;
            this.controlContainerEditor.RenderingControlPropertyName = "Value";
            

            var editingControl = new CellInfoControl();
            editingControl.Name = "EditingControl";
            this.controlContainerEditor.EditingControl = editingControl;
            editingControl.ButtonClick += this.EditingControl_ButtonClick;
            this.controlContainerEditor.EditingControlPropertyName = "Value";
            this.controlContainerEditor.EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick;
        }

        private void EditingControl_ButtonClick(object sender, EventArgs e)
        {
            var activeCell = this.ultraGrid1.ActiveCell;
            var cellString = string.Format("{0}, {1}", activeCell.Column.Index, activeCell.Row.Index);
            MessageBox.Show(string.Format("Button clicked for {0}", cellString));
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (var column in e.Layout.Bands[0].Columns)
            {
                switch (column.Key)
                {
                    case "Column 0":
                        continue;
                    case "Column 1":
                        column.Editor = this.controlContainerEditor;
                        break;
                    default:
                        //column.Hidden = true;
                        column.Editor = this.controlContainerEditor;
                        break;
                }
            }
            
        }

        private void uRGrid_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            UltraGridBand m_band = e.Row.Band;
            //ta.Name = new Font("Trebuchet MS", 7F).ToString();//, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0))).ToString();


            try
            {
                for (int i = 1; i < m_band.Columns.Count; i++)
                {
                    string myValue = (string)e.Row.Cells[i].Value;
                    


                    if (e.Row.Cells[i].Text.Length > 8)
                    {

                        m_band.Columns[i].CellMultiLine = DefaultableBoolean.True;
                        m_band.Columns[i].Width = 200;
                        //e.Row.Height = this.renderingControl.Height;
                        //System.Drawing.Size proposedSize;
                        //proposedSize = TextRenderer.MeasureText(myValue, this.Font);
                        //Size custsize = this.GetPreferredSize(proposedSize);
                        //e.Row.Height = custsize.Height;

                        //this.Width = custsize.Width + 100;
                    }
                    
                   e.Row.PerformAutoSize(); // Auto resize row once value assigned to row...

                }
            }
            catch (Exception ex)
            {

            }
        }
        public override System.Drawing.Size GetPreferredSize(System.Drawing.Size proposedSize)
        {
            if (!base.AutoSize) return base.GetPreferredSize(proposedSize);
            System.Drawing.Size sz = new System.Drawing.Size(50, 50);
            if (proposedSize != System.Drawing.Size.Empty)
            {
                sz.Width = Math.Min(sz.Width, proposedSize.Width);
                sz.Height = Math.Min(sz.Height, proposedSize.Height);
            }
            return sz;
        }
        internal static string GetImageTag(Image image)
        {
            return string.Format("<img align=\"top|right\" style=\"width:{0}px; height:{1}px;\" data=\"{2}\"/>",
                image.Width,
                image.Height,
                Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor.EncodeImage(image));
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
